=== removed file 'ArticleListPage.qml'
--- ArticleListPage.qml	2013-06-15 16:01:24 +0000
+++ ArticleListPage.qml	1970-01-01 00:00:00 +0000
@@ -1,151 +0,0 @@
-import QtQuick 2.0
-import QtQuick.XmlListModel 2.0
-
-import Ubuntu.Components 0.1
-import Ubuntu.Components.ListItems 0.1 as ListItems
-import Ubuntu.Components.Popups 0.1
-
-import "databasemodule_v2.js" as DB2
-
-Page {
-
-    signal backRequst
-    signal articleSelected(var data) // mb id.
-    property string feedLink: ""
-
-    /* 1. Loading data from database by url.
-     * 2. Appending data to ListModel for displaying.
-     */
-    function loadArticles(params) {
-        articleListModel.clear()
-        var res = DB2.loadArticles(params)
-        var entries = res.rows
-
-        for (var i = 0; i < entries.length; i++) {
-            articleListModel.append({"title":entries.item(i).title,
-                                     "content":entries.item(i).content,
-                                     "link":entries.item(i).link,
-                                     "description":entries.item(i).description,
-                                     "pubdate":entries.item(i).pubdate,
-                                     "status":entries.item(i).status,
-                                     "favourite":entries.item(i).favourite,
-                                     "feed_id":entries.item(i).feed_id,
-                                     "guid":entries.item(i).hash})
-        }
-        console.log("Loaded articles, isAll:", params.isAll, " feedId:", params.feedId)
-    }
-
-    onFeedLinkChanged: {
-        loadEntriesByUrl(feedLink)
-    }
-
-    tools: ToolbarActions {
-        back {
-            visible: true
-            onTriggered: {
-                console.log("Back triggered!")
-                backRequst()
-            }
-        }
-    }
-
-    ListView {
-        id: articleList
-
-        clip: true
-        anchors.fill: parent
-
-        model: ListModel {
-            id: articleListModel
-        }
-
-        delegate: ListItems.Subtitled {
-            text: model.title
-            subText: model.pubdate
-            progression: true
-
-            onPressAndHold: {
-                articleList.currentIndex = model.index
-                PopupUtils.open(articleContextMenu, articleList)
-            }
-
-            onClicked: {
-                //mainPageStack.push(singleEntryPage)
-                //singleEntryPage.content.loadHtml((model.content !== "")? model.content : model.description) // FIRST WAY
-                articleSelected((model.content !== "")? model.content : model.description) // FIRST WAY
-            }
-        } // delegate
-    } // ListView
-
-
-    Component {
-        id: articleContextMenu
-
-        /* This new popover works like context menu.
-         * Actions can be reused in toolbar.
-         */
-        ActionSelectionPopover {
-            id: articlePopover
-            actions: ActionList {
-                id: articleActionsList
-                Action {
-                    id: nameActionUpdate
-                    text: i18n.tr("Add to favorites TODO")
-                    onTriggered: {
-
-                    }
-                }
-
-//                Action {
-//                    text: i18n.tr("Edit")
-//                    onTriggered: {
-//                        PopupUtils.close(articlesPopover)
-//                        var data = feedListModel.get(feedList.currentIndex)
-//                        console.log("START EDIT ", data.source, data.status)
-//                        if (data.status == '0') {
-//                            console.log("EDIT ABORT")
-//                            return
-//                        }
-
-//                        PopupUtils.open(popoverSheetComponent, tools, {"isForEdit":true, "itemData" : data})
-//                    }
-//                }
-
-                Action {
-                    text: i18n.tr("Open site")
-                    onTriggered: {
-                        PopupUtils.close(articlePopover)
-                        Qt.openUrlExternally(articleListModel.get(articleList.currentIndex).link)
-                    }
-                }
-            } // ActionList
-        } // ActionSelectionPopover
-    } // Popover component
-
-    /* SECOND WAY OF DISPLAYING FEED. DOES NOT WORK ON MY QT5 LIBS, BUG */
-    //    Flickable {
-    //        id: tmpLabelFlick
-    //        clip: true
-    //        width: parent.width
-
-
-
-    //        anchors {
-    //            top: newsList.bottom
-    //            bottom: parent.bottom
-    //            margins: units.gu(1)
-    //        }
-    //        contentWidth: parent.width
-    //        contentHeight: contentLabel.height
-
-    //        Label {
-    //            id: contentLabel
-
-    //            // text: "Some text! <img src='avatar@8.png'/> Second part of the text!"
-    //            text: "Some text! <img src='/home/qtros/splashScreen_256.png'/> Second part of the text!"
-    //            wrapMode: Text.WordWrap
-    //            width: parent.width
-    //            textFormat: Text.RichText
-    //        }
-    //    }
-}

=== modified file 'feeds/ManageFeedsPage.qml'
--- feeds/ManageFeedsPage.qml	2013-07-24 17:43:11 +0000
+++ feeds/ManageFeedsPage.qml	2013-07-25 19:49:25 +0000
@@ -270,6 +270,7 @@
             property: "tagId"
             criteria: ViewSection.FullString
             delegate: ListItem.Header {
+                // height: units.gu(5)
                 Component.onCompleted: {
                     var s = section
                     for (var i = 0; i < topicListModel.count; i++) {
@@ -385,7 +386,7 @@
                 Action {
                     text: i18n.tr("Edit")
                     onTriggered: {
-                        PopupUtils.close(actionSelectPopover)
+                        // PopupUtils.close(actionSelectPopover)
                         var data = topicListModel.get(topicList.currentIndex)
                         console.log("START EDIT ", data.source, data.status)
                         if (data.status == '0') {
@@ -400,14 +401,12 @@
                 Action {
                     text: i18n.tr("Remove")
                     onTriggered: {
-                        PopupUtils.close(actionSelectPopover)
+                        // PopupUtils.close(actionSelectPopover)
                         var id = topicListModel.get(topicList.currentIndex).feedId
                         var dbResult = DB.deleteFeed(id)
                         if (dbResult.rowsAffected > 0) {
                             DB.clearArticles(id)
-                            for (var i = 0; i < topicListModel.count; i++)
-                                if (topicListModel.get(i).feedId === id)
-                                    topicListModel.remove(i)
+                            topicListModel.remove(topicList.currentIndex)
                         }
                     }
                 }

=== added directory 'listview'
=== added file 'listview/ArticleListPage.qml'
--- listview/ArticleListPage.qml	1970-01-01 00:00:00 +0000
+++ listview/ArticleListPage.qml	2013-07-25 19:49:25 +0000
@@ -0,0 +1,113 @@
+import QtQuick 2.0
+import QtQuick.XmlListModel 2.0
+
+import Ubuntu.Components 0.1
+import Ubuntu.Components.ListItems 0.1 as ListItems
+import Ubuntu.Components.Popups 0.1
+
+import "../databasemodule_v2.js" as DB2
+
+Page {
+
+    signal articleSelected(var data) // mb id.
+    property var updateData: null
+
+    function reloadPageContent() {
+        loadArticles(updateData)
+    }
+
+    /* 1. Loading data from database by url.
+     * 2. Appending data to ListModel for displaying.
+     */
+    function loadArticles(params) {
+        articleListModel.clear()
+
+        var res = DB2.loadArticles(params)
+        var entries = res.rows
+
+        for (var i = 0; i < entries.length; i++) {
+            articleListModel.append({"title":entries.item(i).title,
+                                        "content":entries.item(i).content,
+                                        "link":entries.item(i).link,
+                                        "description":entries.item(i).description,
+                                        "pubdate":entries.item(i).pubdate,
+                                        "status":entries.item(i).status,
+                                        "favourite":entries.item(i).favourite,
+                                        "feed_id":entries.item(i).feed_id,
+                                        "guid":entries.item(i).hash})
+        }
+
+        console.log("Loaded articles, isAll:", params.isAll, " feedId:", params.feedId)
+    }
+
+    ListView {
+        id: articleList
+
+        clip: true
+        anchors.fill: parent
+
+        model: articleListModel
+
+        delegate: ListItems.Subtitled {
+            text: model.title
+            subText: model.pubdate
+            progression: true
+
+            onPressAndHold: {
+                articleList.currentIndex = model.index
+                PopupUtils.open(articleContextMenu, articleList)
+            }
+
+            onClicked: {
+                console.log("ARTICLE SELECTED", model.title)
+                //articleSelected((model.content !== "")? model.content : model.description) // FIRST WAY
+            }
+        } // delegate
+    } // ListView
+
+    ListModel {
+        id: articleListModel
+    }
+
+    Label {
+        id: lblEmptyBase
+
+        text: i18n.tr("There are no articles in selected feed")
+        anchors.centerIn: parent
+        visible: articleListModel.count == 0
+        fontSize: "large"
+    }
+
+
+    /* Useless. All this functions must be available from
+     * RssFeedPage.qml.
+     */
+//    Component {
+//        id: articleContextMenu
+
+//        /* This new popover works like context menu.
+//         * Actions can be reused in toolbar.
+//         */
+//        ActionSelectionPopover {
+//            id: articlePopover
+//            actions: ActionList {
+//                id: articleActionsList
+//                Action {
+//                    id: nameActionUpdate
+//                    text: i18n.tr("Add to favorites TODO")
+//                    onTriggered: {
+
+//                    }
+//                }
+
+//                Action {
+//                    text: i18n.tr("Open in browser")
+//                    onTriggered: {
+//                        PopupUtils.close(articlePopover)
+//                        Qt.openUrlExternally(articleListModel.get(articleList.currentIndex).link)
+//                    }
+//                }
+//            } // ActionList
+//        } // ActionSelectionPopover
+//    } // Popover component
+}

=== added file 'listview/FeedListPage.qml'
--- listview/FeedListPage.qml	1970-01-01 00:00:00 +0000
+++ listview/FeedListPage.qml	2013-07-25 19:49:25 +0000
@@ -0,0 +1,191 @@
+import QtQuick 2.0
+import QtQuick.XmlListModel 2.0
+
+import Ubuntu.Components 0.1
+import Ubuntu.Components.ListItems 0.1 as ListItems
+import Ubuntu.Components.Popups 0.1
+
+import "../databasemodule_v2.js" as DB
+
+Page {
+    id: pageItself
+
+    function reloadPageContent() {
+        feedList.model = null // Sections are not recreated without this line.
+        feedListModel.clear()
+
+        /* Append feeds with topics.
+                 */
+        var allFeeds = DB.loadFeeds()
+        var tags = DB.loadTags()
+
+        for (var i = 0; i < tags.rows.length; i++) {
+            var curTag = tags.rows.item(i) // TMP
+            var feedsByTag = DB.loadFeedsFromTag(curTag.id)
+
+            for (var j = 0; j < feedsByTag.rows.length; j++) {
+                var curFeed = feedsByTag.rows.item(j)
+                feedListModel.append({"tagName":curTag.name,
+                                          "tagId" : curTag.id,
+                                          "feedName" : curFeed.title,
+                                          "feedId" : curFeed.id,
+                                          "feedSource": curFeed.source,
+                                          "feedDescription" : curFeed.description,
+                                          "isSelected" : false })
+            }
+        }
+
+        /* Append rest of feeds.
+                 */
+        var feedsWithoutTopic = DB.loadFeedsWithoutTopic()
+
+        for (var j = 0; j < feedsWithoutTopic.rows.length; j++) {
+            var curFeed = feedsWithoutTopic.rows.item(j)
+
+            feedListModel.append({"tagName": i18n.tr("No topic"),
+                                      "tagId" : 0,
+                                      "feedName" : curFeed.title,
+                                      "feedId" : curFeed.id,
+                                      "feedSource": curFeed.source,
+                                      "feedDescription" : curFeed.description,
+                                      "isSelected" : false })
+        }
+
+        feedList.model = feedListModel
+    }
+
+    ListModel {
+        id: feedListModel
+    }
+
+    ListView {
+        id: feedList
+
+        clip: true
+        anchors.fill: parent
+        model: feedListModel
+
+        header: ListItems.Subtitled {
+            text: i18n.tr("All news")
+            subText: i18n.tr("View news from all channels")
+            progression: true
+            visible: feedListModel.count != 0
+
+            onClicked: {
+                pageStack.push(articleListPage, {"updateData" : {"isAll" : true} })
+            }
+        } // header
+
+        delegate: ListItems.Subtitled {
+            text: (model.feedName == "")? model.feedSource : model.feedName
+            subText: (model.feedDescription !== undefined)? model.feedDescription : ""
+            progression: true
+
+            onPressAndHold: {
+                feedList.currentIndex = model.index
+                PopupUtils.open(popoverComponent, feedList)
+            }
+
+            onClicked: {
+                console.log("Show news in feed:", model.feedSource)
+                pageStack.push(articleListPage, {"updateData" : {"isAll":false, "feedId" : model.feedId} })
+                // pageItself.feedSelected({"isAll":false, "feedId":model.id})
+            }
+        } // delegate
+
+        section {
+            property: "tagId"
+            criteria: ViewSection.FullString
+            delegate: ListItems.Header {
+                // height: units.gu(5)
+                Component.onCompleted: {
+                    var s = section
+                    for (var i = 0; i < feedListModel.count; i++) {
+                        if (feedListModel.get(i).tagId == s) {
+                            text = feedListModel.get(i).tagName
+                            break
+                        }
+                    }
+                }
+            }
+        } // section
+
+    } // ListView
+
+    tools: mainCommonToolbar
+
+    Component {
+        id: popoverComponent
+
+        /* This new popover works like context menu.
+         * Actions can be reused in toolbar.
+         */
+        ActionSelectionPopover {
+            id: popover
+            actions: ActionList {
+                id: popoverActionsList
+                Action {
+                    id: nameActionUpdate
+                    text: i18n.tr("Update")
+                    onTriggered: {
+                        //                        var data = feedListModel.get(feedList.currentIndex)
+                        //                        var feedUrl = data.feedSource
+                        //                        console.log("UPDATE STARTED FOR FEED:", data.feedSource, data.feedId)
+                        //                        pageItself.currentTask = {"operation" : "update", "source" : feedUrl, "feedId" : data.feedId}
+                        //                        thinXmlHttpRequestWraper.loadXml(feedUrl)
+                    }
+                }
+
+                Action {
+                    text: i18n.tr("Edit")
+                    onTriggered: {
+                        var data = feedListModel.get(feedList.currentIndex)
+                        console.log("START EDIT ", data.source, data.status)
+                        if (data.status == '0') {
+                            console.log("EDIT ABORT")
+                            return
+                        }
+
+                        PopupUtils.open(popoverSheetComponent, tools, {"isForEdit":true, "itemData" : data})
+                    }
+                }
+
+                Action {
+                    text: i18n.tr("Open site")
+                    onTriggered: {
+                        Qt.openUrlExternally(feedListModel.get(feedList.currentIndex).feedSource)
+                    }
+                }
+
+                Action {
+                    text: i18n.tr("Remove")
+                    onTriggered: {
+                        var id = feedListModel.get(feedList.currentIndex).feedId
+                        var dbResult = DB.deleteFeed(id)
+                        if (dbResult.rowsAffected > 0) {
+                            DB.clearArticles(id)
+                            feedListModel.remove(feedList.currentIndex)
+                        }
+                    }
+                }
+
+                Action {
+                    text: i18n.tr("Remove all")
+                    onTriggered: {
+                        //DB2.dropTable()
+                        //feedListModel.clear()
+                    }
+                }
+            } // ActionList
+        } // ActionSelectionPopover
+    } // Popover component
+
+    Label {
+        id: lblEmptyBase
+
+        text: i18n.tr("There are no RSS feeds to show")
+        anchors.centerIn: parent
+        visible: feedListModel.count == 0
+        fontSize: "large"
+    }
+} // Page

=== modified file 'ubuntu-rssreader-app.qml'
--- ubuntu-rssreader-app.qml	2013-07-24 21:19:03 +0000
+++ ubuntu-rssreader-app.qml	2013-07-25 19:49:25 +0000
@@ -4,6 +4,7 @@
 import Ubuntu.Components.ListItems 0.1 as ListItem
 import Ubuntu.Components.Popups 0.1
 import "./feeds"
+import "./listview"
 
 import "./databasemodule_v2.js" as DB
 
@@ -76,8 +77,71 @@
         }
 
         onCurrentPageChanged: {
-            console.log("onCurrentPageChanged", currentPage.title)
-            currentPage.reloadPageContent()
+            if (currentPage != null) {
+                console.log("onCurrentPageChanged", currentPage.title)
+                currentPage.reloadPageContent()
+            }
+        }
+
+        ToolbarItems {
+            id: mainCommonToolbar
+
+            back: ToolbarButton {
+                action: Action {
+                    text:  i18n.tr("Refresh")
+                    iconSource: Qt.resolvedUrl("./icons_tmp/reload.svg")
+                    onTriggered:
+                    {
+                        refresh();
+                        toolbar.opened = false;
+                    }
+                }
+            }
+
+            ToolbarButton {
+                action: Action {
+                    id: changeModeAction
+
+                    property bool isListView: false
+
+                    text:  isListView ? i18n.tr("Shorts") : i18n.tr("List view")
+                    iconSource: isListView ? Qt.resolvedUrl("./icons_tmp/view-fullscreen.svg") : Qt.resolvedUrl("./icons_tmp/view-fullscreen.svg")
+                    onTriggered: {
+                        if (isListView) {
+                            pageStack.pop()
+                            pageStack.push(tabs)
+                        } else {
+                            pageStack.pop()
+                            pageStack.push(feedListPage)
+                        }
+
+                        isListView = !isListView
+                        // mainCommonToolbar.opened = false TODO BUG
+                    }
+                }
+            }
+
+            ToolbarButton {
+                id: addReadsBtn
+                action: Action {
+                    text:  i18n.tr("Add reads")
+                    iconSource: Qt.resolvedUrl("./icons_tmp/add.svg")
+                    onTriggered: {
+                        // pageStack.push(editFeedsPage)
+                        PopupUtils.open(addReadsPopoverComp, addReadsBtn)
+                    }
+                }
+            }
+
+            ToolbarButton {
+                action: Action {
+                    text:  i18n.tr("Edit topics")
+                    iconSource: Qt.resolvedUrl("./icons_tmp/edit.svg")
+                    onTriggered: {
+                        pageStack.push(editFeedsPage)
+                    }
+                }
+            }
         }
 
         Page {
@@ -90,53 +154,7 @@
 
             }
 
-            tools: ToolbarItems {
-                id: toolbar
-
-                back: ToolbarButton {
-                    action: Action {
-                        text:  i18n.tr("Refresh")
-                        iconSource: Qt.resolvedUrl("./icons_tmp/reload.svg")
-                        onTriggered:
-                        {
-                            refresh();
-                            toolbar.opened = false;
-                        }
-                    }
-                }
-
-                ToolbarButton {
-                    action: Action {
-                        text:  i18n.tr("List view")
-                        iconSource: Qt.resolvedUrl("./icons_tmp/view-fullscreen.svg")
-                        onTriggered: {
-                            console.log("NOT IMPLEMENTED")
-                        }
-                    }
-                }
-
-                ToolbarButton {
-                    id: addReadsBtn
-                    action: Action {
-                        text:  i18n.tr("Add reads")
-                        iconSource: Qt.resolvedUrl("./icons_tmp/add.svg")
-                        onTriggered: {
-                            // pageStack.push(editFeedsPage)
-                            PopupUtils.open(addReadsPopoverComp, addReadsBtn)
-                        }
-                    }
-                }
-
-                ToolbarButton {
-                    action: Action {
-                        text:  i18n.tr("Edit topics")
-                        iconSource: Qt.resolvedUrl("./icons_tmp/edit.svg")
-                        onTriggered: {
-                            pageStack.push(editFeedsPage)
-                        }
-                    }
-                }
-            }
+            tools: mainCommonToolbar
 
             Component.onCompleted: shorts_view.reload() ;
 
@@ -188,9 +206,9 @@
                             }
                         }
                     } // ActionList
-                }
-            }
-        }
+                } // ActionSelectionPopover
+            } // Component
+        } // Page "Shorts"
 
 
         // ************************************************************* ////////////////////////////////////
@@ -210,6 +228,8 @@
             flickable: null
         } // Page
 
+        // ************************************************************* ////////////////////////////////////
+
         ManageTopicsPage {
             id: manageTopicsPage
             flickable: null
@@ -222,7 +242,7 @@
         AppendFeedPage {
             id: appendFeedPage
 
-            title: "Append feed"
+            title: i18n.tr("Append feed")
             flickable: null
             visible: false
         }
@@ -234,12 +254,32 @@
             id: chooseTopicPage
         }
 
-        // independent page for viewing one RSS feed
-        RssFeedPage
-        {
+        // ************************************************************* ////////////////////////////////////
+
+        RssFeedPage {
             id: feed_page
             visible: false
         }
+
+        // ************************************************************* ////////////////////////////////////
+
+        FeedListPage {
+            id: feedListPage
+
+            title: i18n.tr("Feeds")
+            flickable: null
+            visible: false
+        }
+
+        // ************************************************************* ////////////////////////////////////
+
+        ArticleListPage {
+            id: articleListPage
+
+            title: i18n.tr("Articles")
+            flickable: null
+            visible: false
+        }
     }
 
     XmlNetwork         //  all download and xml parse functions here

